##
##  postgresql.spec -- OpenPKG RPM Specification
##  Copyright (c) 2000-2003 Cable & Wireless Deutschland GmbH
##  Copyright (c) 2000-2003 The OpenPKG Project <http://www.openpkg.org/>
##  Copyright (c) 2000-2003 Ralf S. Engelschall <rse@engelschall.com>
##
##  Permission to use, copy, modify, and distribute this software for
##  any purpose with or without fee is hereby granted, provided that
##  the above copyright notice and this permission notice appear in all
##  copies.
##
##  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
##  WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
##  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
##  IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
##  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
##  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
##  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
##  USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
##  ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
##  OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
##  OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
##  SUCH DAMAGE.
##

#   package versions
%define       V_postgresql  7.3.1
%define       V_libpqxx     4.0

#   package information
Name:         postgresql
Summary:      PostgreSQL Database
URL:          http://www.postgresql.org/
Vendor:       PostgreSQL Group
Packager:     The OpenPKG Project
Distribution: OpenPKG [BASE]
Group:        Database
License:      GPL
Version:      %{V_postgresql}
Release:      20030103

#   package options
%option       with_openssl  no
%option       with_odbc     no
%option       with_perl     no
%option       with_tcl      no

#   list of sources
Source0:      ftp://ftp.postgresql.org/pub/source/v%{V_postgresql}/postgresql-%{V_postgresql}.tar.gz
Source1:      ftp://gborg.postgresql.org/pub/libpqpp/stable/libpq++-%{V_libpqxx}.tar.gz
Source2:      rc.postgresql
Source3:      pg_migrate

#   build information
Prefix:       %{l_prefix}
BuildRoot:    %{l_buildroot}
BuildPreReq:  OpenPKG, openpkg >= 20030103, make, gcc, readline, flex, bison, zlib
PreReq:       OpenPKG, openpkg >= 20030103
%if "%{with_openssl}" == "yes"
BuildPreReq:  openssl
%endif
%if "%{with_odbc}" == "yes"
BuildPreReq:  unixodbc
PreReq:       unixodbc
%endif
%if "%{with_perl}" == "yes"
BuildPreReq:  perl
PreReq:       perl
%endif
%if "%{with_tcl}" == "yes"
BuildPreReq:  tcl
PreReq:       tcl
%endif
AutoReq:      no
AutoReqProv:  no

%description
    PostgreSQL is a sophisticated Object-Relational DBMS, supporting
    almost all SQL constructs, including subselects, transactions,
    and user-defined types and functions. It is the most advanced
    open-source database available anywhere.

%prep
    %setup0 -q
    %setup1 -q -T -D -a 1
    %{l_shtool} subst \
        -e 's;\(#define.*DEFAULT_PGSOCKET_DIR[^"]*"\)/tmp\("\);\1%{l_prefix}/var/postgresql/run\2;' \
        src/include/pg_config.h.in
    case "%{l_target}" in
        *-solaris* )
            %{l_shtool} subst \
                -e 's;^\(sqlmansect *=\).*$;\1 7;' \
                src/makefiles/Makefile.solaris
            ;;
    esac

%build
    #   configure package
    CC="%{l_cc}"; export CC
    CFLAGS="%{l_cflags -O}"; export CFLAGS
    CPPFLAGS="%{l_cppflags}"; export CPPFLAGS
    LDFLAGS="%{l_ldflags}"; export LDFLAGS
%if "%{with_odbc}" == "yes"
%endif
%if "%{with_tcl}" == "yes"
    CFLAGS="$CFLAGS -I%{l_prefix}/include/tcl"
    LDFLAGS="$LDFLAGS -L%{l_prefix}/lib"
%endif
    ./configure \
        --prefix=%{l_prefix} \
%if "%{with_openssl}" == "yes"
        --with-openssl=%{l_prefix} \
%endif
%if "%{with_odbc}" == "yes"
        --enable-odbc \
        --with-unixodbc \
        --with-odbcinst=%{l_prefix}/etc/unixodbc \
%endif
%if "%{with_perl}" == "yes"
        --with-perl \
%endif
%if "%{with_tcl}" == "yes"
        --with-tcl \
%endif
        --without-CXX \
        --disable-syslog

    #   build package
    %{l_make} %{l_mflags -O}

    #   build libpq++ (C++ bindings)
    ( cd libpq++-%{V_libpqxx}
      CXX="%{l_cxx}"
      CFLAGS="%{l_cflags -O}"
      CPPFLAGS="-DHAVE_NAMESPACE_STD -DHAVE_CXX_STRING_HEADER -DDLLIMPORT= "
      CPPFLAGS="$CPPFLAGS -I. -I../src/interfaces -I../src/interfaces/libpq "
      CPPFLAGS="$CPPFLAGS -I../src/include %{l_cppflags}"
      LDFLAGS="%{l_ldflags}"
      OBJS="pgconnection.o pgdatabase.o pgtransdb.o pgcursordb.o pglobject.o"
      for o in $OBJS; do
          $CXX $CFLAGS $CPPFLAGS $LDFLAGS -c -o $o `echo $o | sed -e 's;\.o$;.cc;'`
      done
      rm -f libpq++.a
      ar rc libpq++.a $OBJS
    )

%install
    rm -rf $RPM_BUILD_ROOT

    #   perform standard installation procedure
    %{l_make} %{l_mflags} install DESTDIR=$RPM_BUILD_ROOT

    #   strip down installation
    rm -rf $RPM_BUILD_ROOT%{l_prefix}/doc
    strip $RPM_BUILD_ROOT%{l_prefix}/bin/* >/dev/null 2>&1 || true
    rm -f $RPM_BUILD_ROOT%{l_prefix}/man/man1/pgaccess.1
    rm -f $RPM_BUILD_ROOT%{l_prefix}/man/man1/pgtclsh.1
    rm -f $RPM_BUILD_ROOT%{l_prefix}/man/man1/pgtksh.1
    rm -f $RPM_BUILD_ROOT%{l_prefix}/lib/lib*.so*

    #   namespace adjustments to installation
    for prog in \
        createdb createlang createuser dropdb droplang \
        dropuser initdb initlocation ipcclean vacuumdb; do
        mv $RPM_BUILD_ROOT%{l_prefix}/bin/$prog \
           $RPM_BUILD_ROOT%{l_prefix}/bin/pg_$prog
        mv $RPM_BUILD_ROOT%{l_prefix}/man/man1/$prog.1 \
           $RPM_BUILD_ROOT%{l_prefix}/man/man1/pg_$prog.1
    done
    ( cd $RPM_BUILD_ROOT%{l_prefix}/man/man7
      for man in *.7; do
          mv $man pg_$man
      done
    )

    #   optionally install pgAccess startup wrapper
%if "%{with_tcl}" == "yes"
    ( LD_LIBRARY_PATH=%{l_prefix}/lib:$LD_LIBRARY_PATH
      %{l_prefix}/share/postgresql/pgaccess/main.tcl ${1+"$@"}
    ) >$RPM_BUILD_ROOT%{l_prefix}/bin/pgaccess
    chmod 755 $RPM_BUILD_ROOT%{l_prefix}/bin/pgaccess
%endif

    #   create additional directories
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/var/postgresql/db \
        $RPM_BUILD_ROOT%{l_prefix}/var/postgresql/run

    #   install migration utility
    %{l_shtool} install -c -m 755 \
        -e 's;@l_prefix@;%{l_prefix};g' \
        -e 's;@l_rusr@;%{l_rusr};g' \
        -e 's;@l_rgrp@;%{l_rgrp};g' \
        %{SOURCE pg_migrate} \
        $RPM_BUILD_ROOT%{l_prefix}/bin/

    #   install libpq++ (C++ bindings)
    ( cd libpq++-%{V_libpqxx}
      %{l_shtool} mkdir -f -p -m 755 \
          $RPM_BUILD_ROOT%{l_prefix}/include/libpq++
      %{l_shtool} install -c -m 644 \
          libpq++.h pgconnection.h pgdatabase.h pgtransdb.h pgcursordb.h pglobject.h \
          $RPM_BUILD_ROOT%{l_prefix}/include/libpq++/
      %{l_shtool} install -c -m 644 \
          libpq++.a \
          $RPM_BUILD_ROOT%{l_prefix}/lib/
    )

    #   install run-command script
    %{l_shtool} mkdir -f -p -m 755 \
        $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d
    %{l_shtool} install -c -m 755 \
        -e 's;@l_prefix@;%{l_prefix};g' \
        -e 's;@l_rusr@;%{l_rusr};g' \
        -e 's;@l_rgrp@;%{l_rgrp};g' \
        %{SOURCE rc.postgresql} \
        $RPM_BUILD_ROOT%{l_prefix}/etc/rc.d/

    #   determine installation files
    %{l_rpmtool} files -v -ofiles -r$RPM_BUILD_ROOT \
        %{l_files_std} \
        '%attr(700,%{l_rusr},%{l_rgrp}) %dir %{l_prefix}/var/postgresql/db' \
        '%attr(755,%{l_rusr},%{l_rgrp}) %dir %{l_prefix}/var/postgresql/run'

%files -f files

%clean
    rm -rf $RPM_BUILD_ROOT

%pre
    if [ $1 -eq 1 ]; then
        #   initial installation
        if [ -f $RPM_INSTALL_PREFIX/var/postgresql/db/PG_VERSION -a \
             -f $RPM_INSTALL_PREFIX/bin/pg_migrate ]; then
            #   database migration dumping hint
            v_old_all=`cat $RPM_INSTALL_PREFIX/var/postgresql/db/PG_VERSION`
            v_old_maj=`echo "$v_old_all" | sed -e 's/^\([0-9]*\.[0-9]*\).*/\1/'`
            v_new_all="%{V_postgresql}"
            v_new_maj=`echo "$v_new_maj" | sed -e 's/^\([0-9]*\.[0-9]*\).*/\1/'`
            if [ ".$v_old_maj" != ".$v_new_maj" ]; then
               if [ ! -f $RPM_INSTALL_PREFIX/var/postgresql/db.dump.sql.bz2 -a ".$PG_MIGRATE" != .ignore ]; then
                    ( echo "You are upgrading from PostgreSQL $v_old_all to PostgresSQL $v_new_all,"
                      echo "which is a major version change. We expect a database incompatibility,"
                      echo "so we strongly recommend that you backup your existing database"
                      echo "($RPM_INSTALL_PREFIX/var/postgresql/db/) first by running:"
                      echo "    \$ $RPM_INSTALL_PREFIX/bin/pg_migrate dump"
                      echo "Alternatively, if you want force this package to be installed without"
                      echo "performing a database dump, run the following command before upgrading:"
                      echo "    \$ PG_MIGRATE=ignore; export PG_MIGRATE"
                    ) | %{l_rpmtool} msg -b -t error
                    exit 1
                fi
            fi
        fi
    elif [ $1 -gt 1 ]; then
        #   upgrading of installation
        rm -f $RPM_INSTALL_PREFIX/var/posgresql/RESTART >/dev/null 2>&1 || true
        if [ ".`$l_prefix/etc/rc postgresql status 2>&1 | grep 'is running'`" != . ]; then
            echo "Shutting down currently running database engine." | %{l_rpmtool} msg -b -t notice
            $RPM_INSTALL_PREFIX/etc/rc postgresql stop
            touch $RPM_INSTALL_PREFIX/var/posgresql/RESTART
            sleep 4
        fi
    fi

%post
    if [ $1 -eq 1 ]; then
        #   create initial database
        su - %{l_rusr} -c \
            "LC_CTYPE=C; export LC_CTYPE; umask 022; \
            (echo 'postgresql'; echo 'postgresql') |\
            $RPM_INSTALL_PREFIX/bin/pg_initdb \
                -U postgresql -W -D $RPM_INSTALL_PREFIX/var/postgresql/db" 2>&1 |\
        $RPM_INSTALL_PREFIX/lib/openpkg/shtool prop \
            -p "Creating initial PostgreSQL DB in $RPM_INSTALL_PREFIX/var/postgresql/db"

        #   adjust initial authentication configuration
        cp $RPM_INSTALL_PREFIX/var/postgresql/db/pg_hba.conf \
           $RPM_INSTALL_PREFIX/var/postgresql/db/pg_hba.conf.old
        ( cat $RPM_INSTALL_PREFIX/var/postgresql/db/pg_hba.conf.old |\
          sed -e 's;^\([^#]\);# \1;' -e 's;^$;#;'
          echo ""
          echo "#   OpenPKG PostgreSQL default access policy"
          echo "local all all                           md5"
          echo "host  all all 127.0.0.1 255.255.255.255 md5"
          echo ""
        ) >$RPM_INSTALL_PREFIX/var/postgresql/db/pg_hba.conf
        rm -f $RPM_INSTALL_PREFIX/var/postgresql/db/pg_hba.conf.old

        #   display information about next steps
        ( echo "An initial PostgreSQL DB was created with the two standard"
          echo "databases 'template0' and 'template1'. The owner of both"
          echo "is the DB user 'postgresql'. Its initial password is 'postgresql'."
          echo "After starting PostgreSQL you should change this as quick as"
          echo "possible with the following command:"
          echo "\$ $RPM_INSTALL_PREFIX/bin/psql -U postgresql -d template1 \\"
          echo "  -c \"ALTER USER postgresql WITH PASSWORD '<new-password>'\""
        ) | %{l_rpmtool} msg -b -t notice

        #   optionally link into unixODBC
%if "%{with_odbc}" == "yes"
        ( echo "[PostgreSQL]"
          echo "Description     = PostgreSQL ODBC driver"
          echo "Driver          = $RPM_INSTALL_PREFIX/lib/libodbcpsql.so"
          echo "Setup           = $RPM_INSTALL_PREFIX/lib/libodbcpsqlS.so"
          echo "Threading       = 2"
        ) $RPM_INSTALL_PREFIX/bin/odbcinst -i -d -r
%endif
    elif [ $1 -gt 1 ]; then
        if [ -f $RPM_INSTALL_PREFIX/var/posgresql/RESTART ]; then
            echo "Starting database engine again." | %{l_rpmtool} msg -b -t notice
            $RPM_INSTALL_PREFIX/etc/rc postgresql start
            rm -f $RPM_INSTALL_PREFIX/var/posgresql/RESTART >/dev/null 2>&1 || true
            sleep 2
        fi
        if [ -f $RPM_INSTALL_PREFIX/var/postgresql/db/PG_VERSION -a ".$PG_MIGRATE" != .ignore ]; then
            #   database migration restoring hint
            v_old_all=`cat $RPM_INSTALL_PREFIX/var/postgresql/db/PG_VERSION`
            v_old_maj=`echo "$v_old_all" | sed -e 's/^\([0-9]*\.[0-9]*\).*/\1/'`
            v_new_all="%{V_postgresql}"
            v_new_maj=`echo "$v_new_maj" | sed -e 's/^\([0-9]*\.[0-9]*\).*/\1/'`
            if [ ".$v_old_maj" != ".$v_new_maj" ]; then
                ( echo "You upgraded from PostgreSQL $v_old_all to PostgresSQL $v_new_all,"
                  echo "which is a major version upgrade. We expect a database incompatibility,"
                  echo "so we strongly recommend you to recreate the existing database under"
                  echo "$RPM_INSTALL_PREFIX/var/postgresql/db/ by running the following command:"
                  echo "    \$ $RPM_INSTALL_PREFIX/bin/pg_dump restore"
                ) | %{l_rpmtool} msg -b -t warn
            fi
        fi
    fi

